;*************************************************
;*         YMZ294 player for PB-1000/C           *
;*     (C)2012 Miyura (miyura321@ybb.ne.jp)      *
;*************************************************

PB1000:	EQU	1	;PB-1000
PB1000E:EQU	2	;PB-1000(overseas versions)
PB1000C:EQU	3	;PB-1000C

;-------------------------------------------------
MODEL:	EQU	PB1000
;-------------------------------------------------

#if MODEL=PB1000C
MENU:	EQU	&HEFBB		;MENU mode
#else
MENU:	EQU	&HECA6		;MENU mode
#endif

	ORG	&H7000
	START	INIT
;
;	draw keyboard graphic
;
INIT:	PRE	IX,CGDAT
	PRE	IZ,ORDER
	XRW	$9,$9
	LD	$8,&H82		;left side
	CAL	DRWKB		;
	LD	$8,&H92		;right side
	CAL	DRWKB		;
;
;	reset YMZ294
;
	PST	PE,&HC8
	PST	PD,$31		;reset port3
;
;	initialize resistors
;
	LDW	$20,&H0E0A	;$20: volume
				;$21: octave bias
	LD	$23,&H3F	;$23: channel flag
;
	PST	PD,&HC8		;set port3
;
;	scan membrane keys
;
KYSCN:	PRE	IX,KYDTM
	LD	$0,5		;$0=counter
KYS01:	SB	$0,$30
	JR	C,SCNON

	LDIW	$11,(IX+$31)	;$11=IA, $12=KY
	PST	IA,$11
	LDCM	$0,$0,8		;wait
	GRE	KY,$3
	ANC	$4,$12		;check key code
	JR	Z,KYS01

	SBC	$0,$30
	JR	C,INCVOL	;$0=0:[UP]
	JR	Z,DECVOL	;$0=1:[DOWN]
	SBC	$0,3
	JR	C,INCOCT	;$0=2:[RIGHT]
	JP	NZ,MENU		;$0=4:[MENU]
;
;	change octave bias
;
DECOCT:	SBC	$21,$31		;$0=3:[LEFT]
	JR	Z,KYHLD		;octave down
	SB	$21,14,KYHLD	;

INCOCT:	SBC	$21,28		;
	JR	Z,KYHLD		;octave up
	AD	$21,14,KYHLD	;
;
;	volume control
;
DECVOL:	SBC	$20,$31		;
	JR	LZ,KYHLD	;increment volume
	SB	$20,$30,KYHLD	;

INCVOL:	ADC	$20,$30		;
	JR	LZ,KYHLD	;decrement volume
	AD	$20,$30		;

KYHLD:	GRE	KY,$3		;
	ANC	$4,$12		;check key hold
	JR	NZ,KYHLD	;
	JR	KYSCN
;
;	scan newly pressed key
;
SCNON:	LDIW	$11,(IX+$31)	;$11=IA, $12=KY
	PST	IA,$11
	AD	$0,$30
	SBC	$0,60
	JR	Z,SCOFF
	GRE	KY,$3
	ANC	$3,$12		;check key code
	JR	Z,SCNON		;
;
;	skip already pressed keys
;
	PRE	IZ,KYBUF
	LD	$2,3
KYS02:	LDI	$1,(IZ+$31)
	SBC	$1,$0
	JR	Z,SCNON
	SB	$2,$30
	JR	NZ,KYS02
;
;	select channel
;
	PRE	IX,KYBUF
	LD	$22,3		;max channel number = 3
KYS03:	SB	$22,$30		;all channels are used -> C=1
	JR	C,SCOFF		;
	ADC	(IX+$22),$30	;skip used channel
	JR	NC,KYS03	;
	STD	$0,(IX+$22)	;write code of newly pressed key

	CAL	DRAW		;draw finger graphic
;
;	sound on
;
	PRE	IX,TNDAT	; 
	AD	$0,$21		;load tone data
	BIU	$0		;
	LDW	$11,(IX+$0)	;

	PRE	IX,&H0C00	;set I/O address

	LD	$0,$22		;
	BIU	$0		;set tone (TP7-TP0)
	STD	$0,(IX+$31)	;
	ST	$11,(IX+$30)	;

	AD	$0,$30		;
	STD	$0,(IX+$31)	;set tone (TP11-TP8)
	ST	$12,(IX+$30)	;

	LD	$0,&H08		;
STV01:	STD	$0,(IX+$31)	;
	ST	$20,(IX+$30)	;set volume
	AD	$0,$30		;
	SBC	$0,&H0B		;
	JR	NZ,STV01	;

	CAL	MIXER		;sound on
;
;	scan released key
;
SCOFF:	PRE	IX,KYBUF

	PRE	IZ,KYDAT
	LD	$22,3		;max channel number = 3
KYS04:	SB	$22,$30
	JP	C,KYSCN

	LD	$0,(IX+$22)
	ADC	$0,$30
	JR	C,KYS04

	LD	$5,$0
	BIU	$0
	LDW	$11,(IZ+$0)
	PST	IA,$11
	LDCM	$0,$0,4		;wait
	GRE	KY,$3
	ANC	$3,$12
	JR	NZ,KYS04
;
;	sound off
;
	NA	$0,$31		;write code FFh 
	STD	$0,(IX+$22)	;

	PRE	IX,&H0C00	;sound off
	CAL	MIXER		;

	LD	$0,$5
	CAL	ERASE		;erase finger
	JP	KYSCN
;
;	draw finger
;
DRAW:	LDW	$15,&HB07F	;
	LDW	$17,&HB0B0	;set finger graphic
	LD	$19,&H7F,DRW00
;
;	erase finger
;
ERASE:	ANC	$0,$30
	JR	NZ,ERA01
	PRE	IZ,WHITE
	JR	ERA02
ERA01:	PRE	IZ,BLACK
ERA02:	LDM	$15,(IZ+$31),5	;load key graphic data

DRW00:	LD	$5,$0
	SBC	$0,29		;check G#2
	JR	Z,GS2DR		;
	JR	C,LCD1		;select LCD1/LCD2 ($8)
	SB	$5,30
	LDW	$8,&H0092	;LCD2
	JR	YSET
LCD1:	LDW	$8,&H0C82	;LCD1
;
;	set Y address
;
YSET:	LD	$6,$5
	BID	$6
	JR	C,YST01
	LD	$10,3,XSET	;Y=$10(line 4)
YST01:	LD	$10,2		;Y=$10(line 3)
	AD	$9,6
;
;	set X address
;
XSET:	BIU	$6		;
	BIU	$6		;
	LD	$7,$6		;X=$9+$6x12
	BIU	$7		;
	AD	$7,$6		;
	AD	$9,$7		;
	SBC	$9,96		;check LCD block
	JR	C,DRW01		;
	AD	$9,32		;add offset for block2
DRW01:	CAL	LCDST		;drawing
	STLM	$15,5		;
	RTN
;
;	for G#2
;
GS2DR:	LD	$10,2		;drawing for G#2 key
	LDW	$8,&HDA82	;LCD1
	CAL	LCDST
	STLM	$15,3
	LDW	$8,&H0092	;LCD2
	CAL	LCDST
	STLW	$18
	RTN
;
;	set LCD command
;
LCDST:	PPO	&HC5
	STLM	$8,3
	PPO	&HC4
	RTN
;
;	draw keyboard (half)
;
DRWKB:	CAL	LCDST
	LD	$1,64
DRKB1:	LDI	$0,(IZ+$31)
	LDM	$2,(IX+$0),6
	STLM	$2,6
	SB	$1,$30
	JR	NZ,DRKB1
	RTN
;
;	set sound mix
;
MIXER:	LD	$0,$22
	BIU	$0
	JR	NZ,MIX01
	LD	$0,$30
MIX01:	XR	$23,$0
	LD	$0,&H07
	STD	$0,(IX+$31)
	ST	$23,(IX+$30)
	RTN
;
;	key matrix data
;
KYDTM:	DB	&H5,&H20				; MENU
	DB	&H5,&H40,&H3,&H80,&H4,&H80,&H5,&H80	; LEFT RIGHT  DOWN   UP

KYDAT:	DB	&H4,&H20,&H4,&H10,&H5,&H20,&H4,&H08	; CAPS   A     Z     S
	DB	&H5,&H10,&H1,&H01,&H5,&H08,&H4,&H02	;  X           C     F
	DB	&H5,&H04,&H4,&H01,&H5,&H02,&H1,&H01	;  V     G     B     
	DB	&H5,&H01,&H9,&H80,&H5,&H80,&H9,&H01	;  N     J     M     K
#if MODEL=PB1000E
	DB	&H7,&H01,&H9,&H02,&HB,&H40,&H1,&H01	; ENG    L   SHIFT
#else
	DB	&H7,&H01,&H9,&H02,&HA,&H01,&H1,&H01	; ENG    L    KANA
#endif
	DB	&H9,&H04,&H8,&H04,&H9,&H08,&H8,&H08	;  1     4     2     5
	DB	&H9,&H10,&H1,&H01,&H9,&H20,&H8,&H20	;  3           +     *
	DB	&HA,&H20,&H7,&H20,&H3,&H20,&HC,&H40	;  -     /     Q    FUNC
	DB	&H3,&H10,&H1,&H01,&H3,&H08,&H2,&H10	;  W           E     $
	DB	&H3,&H04,&H2,&H08,&H3,&H02,&H1,&H01	;  R     &     T
	DB	&H3,&H01,&H2,&H02,&H3,&H80,&H2,&H01	;  Y     ;     U     :
	DB	&H8,&H80,&H2,&H80,&H8,&H01,&H1,&H01	;  I     ,     O
	DB	&H8,&H02,&H6,&H80,&H7,&H02,&H1,&H80	;  P    CONT   7    BRK
	DB	&H7,&H04,&H1,&H01,&H7,&H08,&H6,&H02	;  8           9     BS
	DB	&H7,&H10,&H6,&H08,&H6,&H20,&H6,&H10	;  (    INS    )    STOP
;
;	tone data
;
TNDAT:	DW	&H9F7,&H968,&H8E1,&H861,&H7E9,&H000	; G0  G#0  A0  A#0  B0  --
	DW	&H777,&H70C,&H6A7,&H647,&H5ED,&H000	; C1  C#1  D1  D#1  E1  --
	DW	&H598,&H547,&H4FC,&H4B4,&H470,&H431	; F1  F#1  G1  G#1  A1  A#1
	DW	&H3F4,&H000,&H3BC,&H386,&H353,&H324	; B1  --   C2  C#2  D2  D#2
	DW	&H2F6,&H000,&H2CC,&H2A4,&H27E,&H25A	; E2  --   F2  F#2  G2  G#2
	DW	&H238,&H218,&H1FA,&H000,&H1DE,&H1C3	; A2  A#2  B2  --   C3  C#3
	DW	&H1AA,&H192,&H17B,&H000,&H166,&H152	; D3  D#3  E3  --   F3  F#3
	DW	&H13F,&H12D,&H11C,&H10C,&H0FD,&H000	; G3  G#3  A3  A#3  B3  --
	DW	&H0EF,&H0E1,&H0D5,&H0C9,&H0BE,&H000	; C4  C#4  D4  D#4  E4  --
	DW	&H0B3,&H0A9,&H09F,&H096,&H08E,&H086	; F4  F#4  G4  G#4  A4  A#4
	DW	&H07F,&H000,&H077,&H071,&H06A,&H064	; B4  --   C5  C#5  D5  D#5
	DW	&H05F,&H000,&H059,&H054,&H050,&H04B	; E5  --   F5  F#5  G5  G#5
	DW	&H047,&H043,&H03F,&H000,&H03C,&H038	; A5  A#5  B5  --   C6  C#6
	DW	&H035,&H032,&H02F,&H000,&H02D,&H02A	; D6  D#6  E6  --   F6  F#6
	DW	&H028,&H026,&H024,&H022			; G6  G#6  A6  A#6
;
;	keyboard graphic order data (LCD1)
;
ORDER:	DB	&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00 ; line1
	DB	&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00
	DB	&H0C,&H0C,&H0C,&H12,&H06,&H0C,&H12,&H06 ; line2
	DB	&H0C,&H0C,&H12,&H06,&H0C,&H12,&H06,&H0C
	DB	&H2A,&H1E,&H1E,&H24,&H18,&H1E,&H24,&H18 ; line3
	DB	&H1E,&H1E,&H24,&H18,&H1E,&H24,&H18,&H1E
	DB	&H30,&H36,&H36,&H36,&H36,&H36,&H36,&H36 ; line4
	DB	&H36,&H36,&H36,&H36,&H36,&H36,&H36,&H36
;
;	keyboard graphic order data (LCD2)
;
	DB	&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00 ; line1
	DB	&H00,&H00,&H00,&H00,&H00,&H00,&H00,&H00
	DB	&H0C,&H12,&H06,&H0C,&H12,&H06,&H0C,&H0C	; line2
	DB	&H12,&H06,&H0C,&H12,&H06,&H0C,&H0C,&H12
	DB	&H1E,&H24,&H18,&H1E,&H24,&H18,&H1E,&H1E ; line3
	DB	&H24,&H18,&H1E,&H24,&H18,&H1E,&H1E,&H24
	DB	&H36,&H36,&H36,&H36,&H36,&H36,&H36,&H36	; line4
	DB	&H36,&H36,&H36,&H36,&H36,&H36,&H36,&H36
;
;	graphic data
;
CGDAT:	DB	&HFF,&HFF,&HFF,&HFF,&HFF,&HFF	; 0 (&H00)
	DB	&H00,&H00,&H00,&H00,&HFF,&HFF	; 1 (&H06)
	DB	&HFF,&H00,&H00,&H00,&HFF,&HFF	; 2 (&H0C)
	DB	&HFF,&H00,&H00,&H00,&H00,&HFF	; 3 (&H12)
	DB	&H00,&H00,&H00			; 4 (&H18)
BLACK:	DB	&H00,&HFC,&HFF			;
	DB	&HFC,&H00,&H00,&H00,&HFC,&HFF	; 5 (&H1E)
	DB	&HFC,&H00,&H00,&H00,&H00,&HFF	; 6 (&H24)
	DB	&HFF,&H00,&H00,&H00,&HFC,&HFF	; 7 (&H2A)
	DB	&HFE,&H01,&H01,&H01,&H01,&HFE	; 8 (&H30)
WHITE:	DB	&H01,&H01,&H01,&H01,&H01,&HFE	; 9 (&H36)
;
;	input key buffer
;
KYBUF:	DB	&HFF,&HFF,&HFF